///-----------------------------------------------------------------
///
/// @file      FastAcessFrm.cpp
/// @author    Jacek
/// Created:   2010-11-03 19:24:42
/// @section   DESCRIPTION
///            FastAcessFrm class implementation
///
///------------------------------------------------------------------

#include <stdlib.h>
#include "FastAcessFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

#include "methods.cpp"

//----------------------------------------------------------------------------
// FastAcessFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(FastAcessFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(FastAcessFrm::OnClose)
	EVT_SIZE(FastAcessFrm::FastAcessFrmSize)
	EVT_LEFT_UP(FastAcessFrm::FastAcessFrmLeftUP)
	EVT_PAINT(FastAcessFrm::FastAcessFrmPaint)
END_EVENT_TABLE()
////Event Table End

FastAcessFrm::FastAcessFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

FastAcessFrm::~FastAcessFrm()
{
}

void FastAcessFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxMenuBar1 = new wxMenuBar();
	wxMenu *ID_MNU_WYB_RMETODY_1001_Mnu_Obj = new wxMenu(0);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Append(ID_MNU_INTERNAL_1002, wxT("Internal"), wxT(""), wxITEM_RADIO);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Check(ID_MNU_INTERNAL_1002,true);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Append(ID_MNU_DIGITALDIFFERENTIALALGORITHM_1003, wxT("Digital Differential Algorithm"), wxT(""), wxITEM_RADIO);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Check(ID_MNU_DIGITALDIFFERENTIALALGORITHM_1003,false);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Append(ID_MNU_EXTREMALYFASTLINEALGORITHM__1004, wxT("Extremaly Fast Line Algorithm"), wxT(""), wxITEM_RADIO);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Check(ID_MNU_EXTREMALYFASTLINEALGORITHM__1004,false);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->AppendSeparator();
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Append(ID_MNU_NORMAL_1009, wxT("Normal"), wxT(""), wxITEM_RADIO);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Check(ID_MNU_NORMAL_1009,true);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Append(ID_MNU_FAST_1010, wxT("Fast"), wxT(""), wxITEM_RADIO);
	ID_MNU_WYB_RMETODY_1001_Mnu_Obj->Check(ID_MNU_FAST_1010,false);
	WxMenuBar1->Append(ID_MNU_WYB_RMETODY_1001_Mnu_Obj, wxT("Wybr metody"));
	SetMenuBar(WxMenuBar1);

	SetTitle(wxT("FastAcess"));
	SetIcon(wxNullIcon);
	SetSize(8,8,636,470);
	Center();
	
	////GUI Items Creation End
}

void FastAcessFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * FastAcessFrmPaint
 */
void FastAcessFrm::FastAcessFrmPaint(wxPaintEvent& event)
{
 wxPaintDC *MyDC;
 MyDC = new wxPaintDC(this);
 MyDC->SetPen(*wxBLACK);
    
 wxString title,stmp;
 LARGE_INTEGER lpFrequency;
 LARGE_INTEGER lpPerformanceCountStart, lpPerformanceCountEnd;

 if (QueryPerformanceFrequency(&lpFrequency) != 0)
 {
  QueryPerformanceCounter(&lpPerformanceCountStart);

    if (WxMenuBar1->IsChecked(ID_MNU_INTERNAL_1002))
    {
        title="Internal: ";
        Internal_Method(MyDC,this->GetClientSize().GetX(),this->GetClientSize().GetY());
    } else
    if (WxMenuBar1->IsChecked(ID_MNU_DIGITALDIFFERENTIALALGORITHM_1003) && 
        WxMenuBar1->IsChecked(ID_MNU_NORMAL_1009))
    {
        title="DDA: ";
        DDA_Method(MyDC,this->GetClientSize().GetX(),this->GetClientSize().GetY());
    } else
    if (WxMenuBar1->IsChecked(ID_MNU_EXTREMALYFASTLINEALGORITHM__1004) && 
        WxMenuBar1->IsChecked(ID_MNU_NORMAL_1009))
    {
        title="EFLA: ";
        EFLA_Method(MyDC,this->GetClientSize().GetX(),this->GetClientSize().GetY());
    } else    
    if (WxMenuBar1->IsChecked(ID_MNU_DIGITALDIFFERENTIALALGORITHM_1003) && 
        WxMenuBar1->IsChecked(ID_MNU_FAST_1010))
    {
        title="DDA (fast): ";
        DDA_Method_Fast(MyDC,this->GetClientSize().GetX(),this->GetClientSize().GetY());
    }  else
    if (WxMenuBar1->IsChecked(ID_MNU_EXTREMALYFASTLINEALGORITHM__1004) && 
        WxMenuBar1->IsChecked(ID_MNU_FAST_1010))
    {
        title="DDA (fast): ";
        EFLA_Method_Fast(MyDC,this->GetClientSize().GetX(),this->GetClientSize().GetY());
    } 

    QueryPerformanceCounter(&lpPerformanceCountEnd);

    double Frequency = lpFrequency.QuadPart;
    double End = lpPerformanceCountEnd.QuadPart;
    double Start = lpPerformanceCountStart.QuadPart;

    stmp= wxString::Format("%f",((End - Start) / Frequency)) + " s.";
    title = title + stmp;
    this->SetTitle(title);
 }
 delete (MyDC);
}

/*
 * FastAcessFrmSize
 */
void FastAcessFrm::FastAcessFrmSize(wxSizeEvent& event)
{
	this->Refresh();
}

/*
 * FastAcessFrmLeftUP
 */
void FastAcessFrm::FastAcessFrmLeftUP(wxMouseEvent& event)
{
	this->Refresh();
}
