void Internal_Method(wxDC *dc, int Xmax, int Ymax)
{
    int x0,y0,x1,y1;
    for (int i=0; i<5000; i++)
    {
        x0=rand() % Xmax; x1=rand() % Xmax;
        y0=rand() % Ymax; y1=rand() % Ymax;
        dc->DrawLine(x0,y0,x1,y1);
    }
}

void DDA_Method(wxDC *dc, int Xmax, int Ymax)
{
    float x0,y0,x1,y1,m;
    int dx,dy;
 
    for (int i=0; i<5000; i++)
    {
        x0=rand() % Xmax; x1=rand() % Xmax;
        y0=rand() % Ymax; y1=rand() % Ymax;
        if (x1==x0)
            for (int i=int(y0); i<=int(y1); i++) dc->DrawPoint(int(x0),i);
        else
        {
            m=(y1-y0)/(x1-x0);
            if (fabs(m)<=1)
            {
                if (x1>x0) dx=1; else dx=-1;
                    while (x0!=x1)
                    {
                        dc->DrawPoint(int(x0),int(y0+0.5));
                        x0+=dx;
                        y0+=m;
                    }
            }
            else
            {
                m=1/m;
                if (y1>y0) dy=1; else dy=-1;
                    while (y0!=y1)
                    {
                        dc->DrawPoint(int(x0+0.5),int(y0));
                        y0+=dy;
                        x0+=m;
                    }
            }
        }
    }
}

void EFLA_Method(wxDC *dc, int Xmax, int Ymax)
{
    int x0,y0,x1,y1,v;
    int i,j, dx,dy;
 
    for (i=0; i<5000; i++)
    {
        x0=rand() % Xmax; x1=rand() % Xmax;
        y0=rand() % Ymax; y1=rand() % Ymax;
        if (x1==x0)
            for (int i=y0; i<=y1; i++) dc->DrawPoint(x0,i);
        else
        {
            dy=y1-y0;
            dx=x1-x0;
            if (abs(dy)<=abs(dx))
            {
                v=32768+(y0 << 16);
                j=(dy << 16)/dx;
                if (x1>x0)
                    while (x0!=x1)
                    {
                        dc->DrawPoint(x0,v >> 16);
                        v=v+j;
                        x0++;
                    }
                else
                    while (x0!=x1)
                    {
                        dc->DrawPoint(x0,v >> 16);
                        v=v-j;
                        x0--;
                    }
            }
            else
            {
                v=32768+(x0 << 16);
                j=(dx << 16)/dy;
                if (y1>y0)
                    while (y0!=y1)
                    {
                        dc->DrawPoint(v >> 16,y0);
                        v=v+j;
                        y0++;
                    }
                else
                    while (y0!=y1)
                    {
                        dc->DrawPoint(v >> 16,y0);
                        v=v-j;
                        y0--;
                    }
            }
        }
    }
}

unsigned char ImageData[2000][1500];

void DDA_Method_Fast(wxDC *dc, int Xmax, int Ymax)
{
 	for (int i=0; i<Xmax; i++)
	 for (int j=0; j<Ymax; j++)
 	  ImageData[i][j]=192;

    float x0,y0,x1,y1,m;
    int dx,dy;
    for (int i=0; i<5000; i++)
    {
        x0=rand() % Xmax; x1=rand() % Xmax;
        y0=rand() % Ymax; y1=rand() % Ymax;
        if (x1==x0)
            for (int i=int(y0); i<=int(y1); i++) ImageData[int(x0)][i]=0;
        else
        {
            m=(y1-y0)/(x1-x0);
            if (fabs(m)<=1)
            {
                if (x1>x0) dx=1; else dx=-1;
                while (x0!=x1)
                {
                    ImageData[int(x0)][int(y0+0.5)]=0;
                    x0+=dx;
                    y0+=dx*m;
                }
            }
            else
            {
                m=1/m;
                if (y1>y0) dy=1; else dy=-1;
                while (y0!=y1)
                {
                    ImageData[int(x0+0.5)][int(y0)]=0;
                    y0+=dy;
                    x0+=dy*m;
                }
            }
        }
    }

	wxImage img(Xmax,Ymax);
	unsigned char* data = img.GetData();

 	for (int i=0; i<Xmax; i++)
	 for (int j=0; j<Ymax; j++)
	 {
 	      data[j*3*Xmax+3*i]=ImageData[i][j];
 	      data[j*3*Xmax+3*i+1]=ImageData[i][j];
 	      data[j*3*Xmax+3*i+2]=ImageData[i][j];
     }

	wxBitmap bmp = wxBitmap(img);
	if (bmp.Ok()) dc->DrawBitmap(bmp,0,0);
}

void EFLA_Method_Fast(wxDC *dc, int Xmax, int Ymax)
{
 	for (int i=0; i<Xmax; i++)
	 for (int j=0; j<Ymax; j++)
 	  ImageData[i][j]=192;

    int x0,y0,x1,y1,v;
    int j, dx,dy;
    for (int i=0; i<5000; i++)
    {
        x0=rand() % Xmax; x1=rand() % Xmax;
        y0=rand() % Ymax; y1=rand() % Ymax;
        if (x1==x0)
            for (int i=y0; i<=y1; i++) ImageData[x0][i]=0;
        else
        {
            dy=y1-y0;
            dx=x1-x0;
            if (abs(dy)<=abs(dx))
            {
                v=32768+(y0 << 16);
                j=(dy << 16)/dx;
                if (x1>x0)
                while (x0!=x1)
                {
                    ImageData[x0][v >> 16]=0;
                    v=v+j;
                    x0++;
                }
            else
                while (x0!=x1)
                {
                    ImageData[x0][v >> 16]=0;
                    v=v-j;
                    x0--;
                }
            }
            else
            {
                v=32768+(x0 << 16);
                j=(dx << 16)/dy;
                if (y1>y0)
                while (y0!=y1)
                {
                    ImageData[v >> 16][y0]=0;
                    v=v+j;
                    y0++;
                }
                else
                while (y0!=y1)
                {
                    ImageData[v >> 16][y0]=0;
                    v=v-j;
                    y0--;
                }
            }
        }
    }

	wxImage img(Xmax,Ymax);
	unsigned char* data = img.GetData();

 	for (int i=0; i<Xmax; i++)
	 for (int j=0; j<Ymax; j++)
	 {
 	      data[j*3*Xmax+3*i]=ImageData[i][j];
 	      data[j*3*Xmax+3*i+1]=ImageData[i][j];
 	      data[j*3*Xmax+3*i+2]=ImageData[i][j];
     }

	wxBitmap bmp = wxBitmap(img);
	if (bmp.Ok()) dc->DrawBitmap(bmp,0,0);
}
