//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

int Xmax, Ymax;

void Internal_Method(TCanvas *Canvas)
{
 int x0,y0,x1,y1;
 for (int i=0; i<5000; i++)
 {
  x0=random(Xmax); x1=random(Xmax);
  y0=random(Ymax); y1=random(Ymax);
  Canvas->MoveTo(x0,y0);
  Canvas->LineTo(x1,y1);
 }
}

void DDA_Method(TCanvas *Canvas)
{
 float x0,y0,x1,y1,m;
 int dx,dy;
 for (int i=0; i<5000; i++)
 {
  x0=random(Xmax); x1=random(Xmax);
  y0=random(Ymax); y1=random(Ymax);
//  x0=10; x1=30;
//  y0=200; y1=30;
  if (x1==x0)
   for (int i=y0; i<=y1; i++) Canvas->Pixels[x0][i]=clBlack;
  else
  {
   m=(y1-y0)/(x1-x0);
   if (fabs(m)<=1)
   {
    if (x1>x0) dx=1; else dx=-1;
    while (x0!=x1)
    {
     Canvas->Pixels[x0][y0+0.5]=clBlack;
     x0+=dx;
     y0+=m;
    }
   }
   else
   {
    m=1/m;
    if (y1>y0) dy=1; else dy=-1;
    while (y0!=y1)
    {
     Canvas->Pixels[x0+0.5][y0]=clBlack;
     y0+=dy;
     x0+=m;
    }
   }
  }
 }
}

void EFLA_Method(TCanvas *Canvas)
{
 int x0,y0,x1,y1,v;
 int i,j, dx,dy;
 for (i=0; i<5000; i++)
 {
  x0=random(Xmax); x1=random(Xmax);
  y0=random(Ymax); y1=random(Ymax);
//  x0=10; x1=30;
//  y0=200; y1=30;
  if (x1==x0)
   for (int i=y0; i<=y1; i++) Canvas->Pixels[x0][i]=clBlack;
  else
  {
   dy=y1-y0;
   dx=x1-x0;
   if (abs(dy)<=abs(dx))
   {
    v=32768+(y0 << 16);
    j=(dy << 16)/dx;
    if (x1>x0)
     while (x0!=x1)
     {
      Canvas->Pixels[x0][v >> 16]=clBlack;
//SetPixel(Canvas->Handle,x0,v >> 16,0);

      v=v+j;
      x0++;
     }
    else
     while (x0!=x1)
     {
      Canvas->Pixels[x0][v >> 16]=clBlack;
//SetPixel(Canvas->Handle,x0,v >> 16,0);
      v=v-j;
      x0--;
     }
   }
   else
   {
    v=32768+(x0 << 16);
    j=(dx << 16)/dy;
    if (y1>y0)
     while (y0!=y1)
     {
      Canvas->Pixels[v >> 16][y0]=clBlack;
//SetPixel(Canvas->Handle,v >> 16,y0,0);
      v=v+j;
      y0++;
     }
    else
     while (y0!=y1)
     {
      Canvas->Pixels[v >> 16][y0]=clBlack;
//SetPixel(Canvas->Handle,v >> 16,y0,0);
      v=v-j;
      y0--;
     }
   }
  }
 }
}


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 AnsiString stmp;
 LARGE_INTEGER lpFrequency;
 LARGE_INTEGER lpPerformanceCountStart, lpPerformanceCountEnd;

 if (QueryPerformanceFrequency(&lpFrequency) != 0)
 {
  QueryPerformanceCounter(&lpPerformanceCountStart);
  if (Internal1->Checked) {Internal_Method(Canvas); stmp="Internal: ";};
  if (DDA1->Checked) {DDA_Method(Canvas); stmp="DDA: ";};
  if (EFLA1->Checked) {EFLA_Method(Canvas); stmp="EFLA: ";};
  QueryPerformanceCounter(&lpPerformanceCountEnd);

  double Frequency = lpFrequency.QuadPart;
  double End = lpPerformanceCountEnd.QuadPart;
  double Start = lpPerformanceCountStart.QuadPart;

  Caption = stmp + FloatToStr((End - Start) / Frequency) + " s.";
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
 Xmax=ClientWidth;
 Ymax=ClientHeight;
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClick(TObject *Sender)
{
 Invalidate();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Internal1Click(TObject *Sender)
{
 Internal1->Checked=true;
 DDA1->Checked=false;
 EFLA1->Checked=false;
 Invalidate(); 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DDA1Click(TObject *Sender)
{
 Internal1->Checked=false;
 DDA1->Checked=true;
 EFLA1->Checked=false;
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EFLA1Click(TObject *Sender)
{
 Internal1->Checked=false;
 DDA1->Checked=false;
 EFLA1->Checked=true;
 Invalidate();
}
//---------------------------------------------------------------------------

