//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

BYTE ImageData[4*1680][1050], *LinePtr;

int Xmax, Ymax;

void ClearImageData()
{
 for (int i=0; i<1680; i++)
  for (int j=0; j<1050; j++)
   ImageData[i][j]=192;
}

void DDA_Method()
{
 float x0,y0,x1,y1,m;
 int dx,dy;
 for (int i=0; i<5000; i++)
 {
  x0=random(Xmax); x1=random(Xmax);
  y0=random(Ymax); y1=random(Ymax);
  if (x1==x0)
   for (int i=y0; i<=y1; i++) ImageData[int(x0)][i]=0;
  else
  {
   m=(y1-y0)/(x1-x0);
   if (fabs(m)<=1)
   {
    if (x1>x0) dx=1; else dx=-1;
    while (x0!=x1)
    {
     ImageData[int(x0)][int(y0+0.5)]=0;
     x0+=dx;
     y0+=dx*m;
    }
   }
   else
   {
    m=1/m;
    if (y1>y0) dy=1; else dy=-1;
    while (y0!=y1)
    {
     ImageData[int(x0+0.5)][int(y0)]=0;
     y0+=dy;
     x0+=dy*m;
    }
   }
  }
 }
}

void EFLA_Method()
{
 int x0,y0,x1,y1,v;
 int i,j, dx,dy;
 for (i=0; i<5000; i++)
 {
  x0=random(Xmax); x1=random(Xmax);
  y0=random(Ymax); y1=random(Ymax);
  if (x1==x0)
   for (int i=y0; i<=y1; i++) ImageData[x0][i]=0;
  else
  {
   dy=y1-y0;
   dx=x1-x0;
   if (abs(dy)<=abs(dx))
   {
    v=32768+(y0 << 16);
    j=(dy << 16)/dx;
    if (x1>x0)
     while (x0!=x1)
     {
      ImageData[x0][v >> 16]=0;
      v=v+j;
      x0++;
     }
    else
     while (x0!=x1)
     {
      ImageData[x0][v >> 16]=0;
      v=v-j;
      x0--;
     }
   }
   else
   {
    v=32768+(x0 << 16);
    j=(dx << 16)/dy;
    if (y1>y0)
     while (y0!=y1)
     {
      ImageData[v >> 16][y0]=0;
      v=v+j;
      y0++;
     }
    else
     while (y0!=y1)
     {
      ImageData[v >> 16][y0]=0;
      v=v-j;
      y0--;
     }
   }
  }
 }
}


void __fastcall TForm1::Draw()
{
 AnsiString stmp;
 LARGE_INTEGER lpFrequency;
 LARGE_INTEGER lpPerformanceCountStart, lpPerformanceCountEnd;

 if (QueryPerformanceFrequency(&lpFrequency) != 0)
 {
  QueryPerformanceCounter(&lpPerformanceCountStart);
  if (DDA1->Checked) {DDA_Method(); stmp="DDA: ";};
  if (EFLA1->Checked) {EFLA_Method(); stmp="EFLA: ";};
  QueryPerformanceCounter(&lpPerformanceCountEnd);

  double Frequency = lpFrequency.QuadPart;
  double End = lpPerformanceCountEnd.QuadPart;
  double Start = lpPerformanceCountStart.QuadPart;

  Caption = stmp + FloatToStr((End - Start) / Frequency) + " s.";
 }
}

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
 Xmax=ClientWidth;
 Ymax=ClientHeight;
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DDA1Click(TObject *Sender)
{
 DDA1->Checked=true;
 EFLA1->Checked=false;
 ClearImageData(); 
 Draw();
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EFLA1Click(TObject *Sender)
{
 DDA1->Checked=false;
 EFLA1->Checked=true;
 ClearImageData();
 Draw();
 Invalidate();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
 Image1->Picture->Bitmap=new Graphics::TBitmap;
 Image1->Picture->Bitmap->PixelFormat=pf24bit;
 Image1->Picture->Bitmap->Width=1680;
 Image1->Picture->Bitmap->Height=1050;
 Image1->Picture->Bitmap->Canvas->MoveTo(10,10);
 ClearImageData();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
 Draw();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int x,y;
 for (y=0; y<Ymax; y++)
 {
  LinePtr= (BYTE *) Image1->Picture->Bitmap->ScanLine[y];
  for (x=0; x<Xmax; x++)
  {
   LinePtr[x*3]=ImageData[x][y];
   LinePtr[x*3+1]=ImageData[x][y];
   LinePtr[x*3+2]=ImageData[x][y];
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1Click(TObject *Sender)
{
 ClearImageData();
 Draw();
 Invalidate();        
}
//---------------------------------------------------------------------------

