//---------------------------------------------------------------------------
#include <math.h>
#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "macierz.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

FPOINT Pts[36];
int NPts;
float Scale;
int x0,y0;

void InitPts()
{
 int i;
 //prostokat
 Pts[0].x=-1; Pts[0].y=-1;
 Pts[1].x=-1; Pts[1].y=1;
 Pts[2].x=2; Pts[2].y=1;
 Pts[3].x=2; Pts[3].y=-1;
 //trojkat
 Pts[4].x=-2; Pts[4].y=-0.5;
 Pts[5].x=-1; Pts[5].y=2.5;
 Pts[6].x=1.5; Pts[6].y=-0.5;
 //kolko
 for (i=0; i<28; i++)
 {
  Pts[7+i].x=0.5+0.7*cos(i*M_PI/18);
  Pts[7+i].y=1+0.7*sin(i*M_PI/18);
 }
}

void Draw(TCanvas *Canvas, int Start, int End, bool Closed)
{
 int i;
 Canvas->MoveTo(x0+Scale*Pts[Start].x+0.5,y0-Scale*Pts[Start].y+0.5);
 for (i=Start+1; i<End+1; i++)
  Canvas->LineTo(x0+Scale*Pts[i].x+0.5,y0-Scale*Pts[i].y+0.5);
 if (Closed) Canvas->LineTo(x0+Scale*Pts[Start].x+0.5,y0-Scale*Pts[Start].y+0.5);
}

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int w,h;
 int i,x,y;

 x0=ClientWidth/2;
 y0=ClientHeight/2;
 w=ClientWidth;
 h=ClientHeight;
 //ramka
 Canvas->Rectangle(10,10,w-10,h-10);
 //osie
 Canvas->MoveTo(20,y0); Canvas->LineTo(w-20,y0);
 Canvas->MoveTo(x0,20); Canvas->LineTo(x0,h-20);
 Canvas->MoveTo(x0-10,30); Canvas->LineTo(x0,20); Canvas->LineTo(x0+10,30);
 Canvas->MoveTo(w-30,y0-10); Canvas->LineTo(w-20,y0); Canvas->LineTo(w-30,y0+10);

 //podzialka na osiach
 i=0; y=y0;
 do
 {
  Canvas->MoveTo(x0-3,y); Canvas->LineTo(x0+3,y);
  i++; y=y0-i*Scale;
 } while (y>30);
 i=0; y=y0;
 do
 {
  Canvas->MoveTo(x0-3,y); Canvas->LineTo(x0+3,y);
  i++; y=y0+i*Scale;
 } while (y<h-20);
 i=0; x=x0;
 do
 {
  Canvas->MoveTo(x,y0-3); Canvas->LineTo(x,y0+3);
  i++; x=x0+i*Scale;
 } while (x<w-30);
 i=0; x=x0;
 do
 {
  Canvas->MoveTo(x,y0-3); Canvas->LineTo(x,y0+3);
  i++; x=x0-i*Scale;
 } while (x>20);
 Canvas->Pen->Color=clBlue;
 Draw(Canvas,0,3,true);
 Draw(Canvas,4,6,true);
 Draw(Canvas,7,33,false);
 Canvas->Pen->Color=clBlack;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 InitPts();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
 float Sx,Sy;
 Sx=(ClientWidth-20)/8;
 Sy=(ClientHeight-20)/8;
 if (Sx<Sy) Scale=Sx; else Scale=Sy;
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
 Form2->Show();        
}
//---------------------------------------------------------------------------
