//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Device.h"
#include "Real.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define MAXPNT 29

extern TPoint pnt1[MAXPNT],pnt2[MAXPNT];
TPoint dev_pnt1[MAXPNT],dev_pnt2[MAXPNT];
float x0,y0,x1,y1;
int Xmin,Ymin,Xmax,Ymax;
float SX,SY;

bool Cohen_Sutherland(TPoint &p1, TPoint &p2)
{
 float xt,yt;
 float xp,xk,yp,yk;
 xp=p1.x; yp=p1.y;
 xk=p2.x; yk=p2.y;
 int C1=0,C2=0;
 if (xp<Xmin) C1+=1;    if (xk<Xmin) C2+=1;
 if (xp>Xmax) C1+=2;    if (xk>Xmax) C2+=2;
 if (yp<Ymin) C1+=4;    if (yk<Ymin) C2+=4;
 if (yp>Ymax) C1+=8;    if (yk>Ymax) C2+=8;

 if (C1==0 && C2==0) return (true);
 if (C1 & C2) return (false);

 if (C1==0) {xt=xp; yt=yp; xp=xk; yp=yk; xk=xt; yk=yt; C1=C2;}

 if (C1 & 1) {yp=yp+(Xmin-xp)*(yk-yp)/(xk-xp); xp=Xmin;}
  else
  if (C1 & 2) {yp=yp+(Xmax-xp)*(yk-yp)/(xk-xp); xp=Xmax;}
   else
   if (C1 & 4) {xp=xp+(Ymin-yp)*(xk-xp)/(yk-yp); yp=Ymin;}
    else
    if (C1 & 8) {xp=xp+(Ymax-yp)*(xk-xp)/(yk-yp); yp=Ymax;}  
 p1=TPoint(xp,yp); p2=TPoint(xk,yk);
 return (true);
}

TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormPaint(TObject *Sender)
{
 int i;


 SX=(Xmax-Xmin)/(x1-x0);
 SY=(Ymax-Ymin)/(y1-y0);

 if (MI_Zachowaj->Checked)
  if (SX<SY) SY=SX; else SX=SY;

 Canvas->Pen->Color=clRed;
 Canvas->Rectangle(Xmin,Ymin,Xmax,Ymax);
 Canvas->Pen->Color=clBlack;

 for (i=0; i<MAXPNT; i++)
 {
  dev_pnt1[i].x=SX*pnt1[i].x-x0*SX+Xmin;
  dev_pnt1[i].y=SY*pnt1[i].y-y0*SY+Ymin;
  dev_pnt2[i].x=SX*pnt2[i].x-x0*SX+Xmin;
  dev_pnt2[i].y=SY*pnt2[i].y-y0*SY+Ymin;
 }

 if (MI_Obcinaj->Checked)
 {
  for (i=0; i<MAXPNT; i++)
  if (Cohen_Sutherland(dev_pnt1[i],dev_pnt2[i]))
  {
   Canvas->MoveTo(dev_pnt1[i].x,dev_pnt1[i].y);
   Canvas->LineTo(dev_pnt2[i].x,dev_pnt2[i].y);
  }
 }
 else
 for (i=0; i<MAXPNT; i++)
 {
  Canvas->MoveTo(dev_pnt1[i].x,dev_pnt1[i].y);
  Canvas->LineTo(dev_pnt2[i].x,dev_pnt2[i].y);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormClose(TObject *Sender, TCloseAction &Action)
{
 Form1->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::MI_ZachowajClick(TObject *Sender)
{
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::MI_ObcinajClick(TObject *Sender)
{
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
 if (Button==mbLeft) {Xmin=X; Ymin=Y;};
 if (Button==mbRight) {Xmax=X; Ymax=Y;};
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormShow(TObject *Sender)
{
 Xmin=Ymin=0;
 Xmax=ClientWidth;
 Ymax=ClientHeight;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormCreate(TObject *Sender)
{
 Xmin=Ymin=0;
 Xmax=ClientWidth;
 Ymax=ClientHeight;
}
//---------------------------------------------------------------------------
